# -*- coding: utf-8 -*-
"""

Standardregelstrecke mit PI-Regler Beispiel 3.4

Created on 21.3. 2019, modifiziert für Version 0.10.1 am 19.8.24
@author: philippsen
"""

import numpy as np
import control as ct
import matplotlib.pyplot as plt

a0 = 1.; a1 = 10. ; a2 = 31. ; a3 = 30.
b0 = 1.
num  = np.array([b0])
den  = np.array([a3, a2, a1, a0])

strecke = ct.tf(num,den)
#regler = tf([5, 1],[5, 0]) # PI-Regler
regler = ct.tf([5],[1])
G0 = regler*strecke  # Reihenschaltung R(s) und G(s)
print('G0 =',G0.name)
ct.bode_plot(G0,title='Bode-Plot',label=['G0'])

gm, pm, wg, wp = ct.margin(G0)
gmdb = 20*np.log10(gm); wphz = wp/(2*np.pi)
print('Amplitudenreserve = ',gm,' in dB = ',gmdb)
print('Phasenreserve = ',pm)
print('Durchtrittsfrequenz = ',wp,' in Hertz = ',wphz)

Gw = ct.feedback(G0, 1) 
ct.bode_plot(Gw,title='Bode-Plot',label=['Gw'])
plt.figure()
t, y = ct.step_response(Gw)
plt.plot(t,y)
plt.title('Regelkreis Sprungantwort')
plt.xlabel('t [s]'); plt.ylabel('h(t)')
plt.grid()
plt.show()
plt.figure()
ct.nyquist_plot(G0,title='Ortskurve G0') 
plt.figure()
# oder mit Matplotlib direkt
res = ct.nyquist_response(G0) 
plt.plot(res.response.real,res.response.imag)
plt.title('Ortskurve G0 mit Matplotlib')
plt.xlabel('Real'); plt.ylabel('Imag')
plt.grid(True)