# -*- coding: utf-8 -*-
"""
P-T2s Modifikation Dämpfung Batchbetrieb
Created on 2.4. 2019, modifiziert für Version 0.10.1 am 19.8.24
@author: philippsen
"""

import numpy as np
import control as ct
import matplotlib.pyplot as plt
k=11
wurz = np.zeros((k,2),dtype=np.complex_)

for ii in range(0, k): # Liste von 0 bis kk-1
    d = 1.2 - 0.1*ii
    den  = np.array([1,2*d, 1])
    print("d = %3.2f, Pole = %s " %(d,str(np.roots(den))) )
    wurz[ii,:] = np.roots(den)
    pt2 = ct.tf(1,den)
    t, y = ct.step_response(pt2)
    plt.plot(t,y)

plt.title('P-T2s Batch')
plt.xlabel('t [s]'); plt.ylabel('h(t)')    
plt.grid()

plt.figure()
response = ct.pole_zero_map(pt2)
ct.pole_zero_plot(response)
plt.grid()