# -*- coding: utf-8 -*-
"""
Totzeit mit P-T1 Pade-Approximation
Created on 10.4. 2019, mod 15.4.24 und 20.8.24
Neues Plot-Paradigma ab Version 0.10.0 für bode und nyquist
@author: philippsen
"""

import control as ct
import numpy as np
import matplotlib.pyplot as plt

T = 1       # Zeitkonstante P-T1
TT = 0.5    # Totzeit

n = 500 # Anzahl Schritte
T0 = 0.01 # Abtastzeit
u = np.zeros(n)     # Vektor Eingangsgröße
tk= np.arange(0,T0*n,T0)    # Zeit- bzw. k-Achse

ab = round(TT/T0)
for i in range(ab, n):  # Verschiebung um Totzeit
     u[i] = 1.0

G1 = ct.tf([ 1],[T, 1]) # P-T1
tk, yout = ct.forced_response(G1, tk, u, X0=0)

num, den = ct.pade(TT,3)   # Pade Appr. 3.Ordnung
Gpade = ct.tf(num,den)
Gers = G1*Gpade
tk, x = ct.step_response(Gers, tk)#, X0=0)
plt.plot(tk,yout, tk, x)
plt.title('Totzeit-P-T1 und Pade-Approx.')
plt.xlabel('t [s]'); plt.ylabel('x')
plt.grid(True)
plt.figure()
ct.bode_plot(Gers,title='Bode-Plot G Ersatz',label=[''])