# -*- coding: utf-8 -*-
"""
Ortskurven, h(t) Standardregelstrecke und PI-Regler

Created on 21.3. 2019, mod 15.4.24, modifiziert für Version 0.10.1 am 19.8.24
@author: philippsen
"""

import numpy as np
import control as ct
import matplotlib.pyplot as plt

a0 = 1.; a1 = 10. ; a2 = 31. ; a3 = 30.
b0 = 1.
num  = np.array([b0])
den  = np.array([a3, a2, a1, a0])

strecke = ct.matlab.tf(num,den)
regler = 1.0
G0 = regler*strecke
# Hinweis: mit print(G0.name) kann interne Systemnummer angezeigt werden
res = ct.nyquist_response(G0) 
plt.plot(res.response.real,res.response.imag, "b")
res = ct.nyquist_response(2*G0) 
plt.plot(res.response.real,res.response.imag, "r")
res = ct.nyquist_response(4*G0) 
plt.plot(res.response.real,res.response.imag, "g")

plt.title('Ortskurven G0 Verstärkung 1, 2, 4')
plt.xlabel('Real'); plt.ylabel('Imag')
plt.grid()
plt.show()
plt.figure()
Gw = ct.matlab.feedback(G0, 1) #   Kreis
xx, tt = ct.matlab.step(Gw)
plt.plot(tt,xx,"b")
Gw = ct.matlab.feedback(2*G0, 1) #   Kreis
xx, tt = ct.matlab.step(Gw)
plt.plot(tt,xx,"r")
Gw = ct.matlab.feedback(4*G0, 1) #   Kreis
xx, tt = ct.matlab.step(Gw)
plt.plot(tt,xx,"g")
plt.title('Sprungantwort Regelkreis für Kp=1, 2, 4')
plt.xlabel('t [s]'); plt.ylabel('x(t)')
plt.grid()
plt.show()
#plt.gcf().clear() # So wird Plot gelöscht