# -*- coding: utf-8 -*-
"""
Erzeugung eines Mehrgrößensystems mit der
Python Control Lib und Berechnung der statischen Entkopplung.
slycot erforderlich

statische Entkopplung funktioniert nicht im Fall
integralwirkende Strecke!

Created on 22.4. 2019, mod. 20.8.24
@author: philippsen
"""

import numpy as np
import control as ct
import matplotlib.pyplot as plt

#Gii(s) = 2/2s^2 + 3s +1    Gij = 0.5/2s+1
n11= [2.0]; d11= [2., 3., 1.]
n22= [2.0]; d22= [2., 3., 1.]
n12= [0.5]; d12= [2., 1.]
n21= [0.5]; d21= [2., 1.]
g11 = ct.tf(n11,d11); g110 = ct.dcgain(g11)
g12 = ct.tf(n12,d12); g120 = ct.dcgain(g12)
g22 = ct.tf(n22,d22); g220 = ct.dcgain(g22)
g21 = ct.tf(n21,d21); g210 = ct.dcgain(g21)
        
num = [[n11, n12], [n21, n22]]
den = [[d11, d12], [d21, d22]]
strecke = ct.tf(num, den)
k= g110*g220/(g110*g220 - g210*g120)

ne = [[[k], [-k*g120/g110]], [[-k*g210/g220], [k]]]
de = [[[1.], [1.]], [[1.], [1.]]]
ent = ct.tf(ne, de)
ct.step_response(strecke).plot(label='ohne Entk.')
#plt.figure()
ct.step_response(ent*strecke).plot(
    title='Sprungantwort Mimo stat. Entkopplung',label='mit Entk.')