# -*- coding: utf-8 -*-
"""
Standardregelstrecke im Zustandsraum in RNF
Created on 12.4. 2019, mod. 20.8.24
@author: philippsen
"""

import numpy as np
import control as ct
import matplotlib.pyplot as plt

a0 = 1./30.
a1 = 10./30.
a2 = 31./30.
b0 = 1./30.
A  = np.array([[0, 1.,0 ],[ 0, 0, 1. ],[ -a0, -a1, -a2]])
b  = np.array([[0.],[ 0. ],[ 1.]])
c  = np.array([b0, 0,0 ])
stand = ct.ss(A, b, c, 0)

#T = np.linspace(0, 40,num=200)
#t, y, x = ct.forced_response(stand,T,U=1,X0=0,return_x=True)
t, y, x = ct.step_response(stand,return_x=True) # mit Zuständen

plt.plot(t,y)
plt.title('Standardregelstrecke im Zustandsraum, RNF')
plt.xlabel('t [s]'); plt.ylabel('h(t)')    
plt.grid()