# -*- coding: utf-8 -*-
"""

Modellreduktion Standardregelstrecke
Created on 4.1. 2022, mod. 20.8.24
@author: philippsen
"""

import numpy as np
import control as ct
import matplotlib.pyplot as plt
plt.rcParams['pdf.fonttype'] = 42
plt.rcParams['ps.fonttype'] = 42

g3 = ct.tf(1,[30, 31, 10, 1])  # Standardregelstrecke
s3 = ct.tf2ss(g3)

t, x = ct.step_response(g3)
plt.figure(1)
plt.plot(t,x)

b2 = ct.balred(s3,2, method='matchdc') 
#b2 = balred(s3,2, method='truncate') #
gb2 = ct.ss2tf(b2)
print('G(s) = ',gb2)
print(ct.poles(gb2))
t, xx = ct.step_response(b2,t)
plt.plot(t,xx)

plt.title('Standardregelstrecke und balred Ersatzmodell')
plt.xlabel('t [s]')
plt.ylabel('x')
plt.grid()

g2 = ct.tf(1,[25,10,1]) #Ersatzmodell 2. Ordnung T1=T2=5
t, xxx = ct.step_response(g2,t)
plt.figure(2)
plt.plot(t,x,t,xxx)
plt.title('Standardregelstrecke und P-T2 Ersatzmodell')
plt.xlabel('t [s]')
plt.ylabel('x')
plt.grid()
